#pragma once

#include "preferences.h"
#include "wizard.h"
#include "TreeOptionsCtrlEx.h"

// CPPgTweaks dialog

class CPPgTweaks : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgTweaks)

public:
	CPPgTweaks();
	virtual ~CPPgTweaks();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs;}

// Dialog Data
	enum { IDD = IDD_PPG_TWEAKS };
protected:
	CPreferences *app_prefs;
	uint8 m_iFileBufferSize;
	uint8 m_iQueueSize;
	int m_iMaxConnPerFive;
	int m_iAutoTakeEd2kLinks;
	int m_iVerbose;
	int m_iDebugSourceExchange;
	int m_iCreditSystem;
	int m_iLog2Disk;
	int m_iDebug2Disk;
	int m_iCommitFiles;
	int m_iFilterLANIPs;
	int m_iExtControls;
	UINT m_uServerKeepAliveTimeout;
	int m_iPawcioCredits; //Pawcio: Credits
	int m_iRedFiles; //Pawcio: Red Files
	int m_iWQOF; //Xman: Waiting Queue Overflow
	int m_iCheckDiskspace;	// SLUGFILLER: checkDiskspace
	float m_fMinFreeDiskSpaceMB;
	CString m_sYourHostname;	// itsonlyme: hostnameSource
	int m_bEnableAntiLeecher; //MORPH - Added by IceCream, enable Anti-leecher
	int m_bEnableAntiCreditHack; //MORPH - Added by IceCream, enable Anti-CreditHack
	int m_bIsAutoPowershareNewDownloadFile; //MORPH - Added by SiRoB, Avoid misusing of powersharing
	// SLUGFILLER: hideOS
	int m_iHideOS;
	int m_iSelectiveShare;
	// SLUGFILLER: hideOS
	int m_iInfiniteQueue;	// SLUGFILLER: infiniteQueue
	int m_iDropHQRS;//Pawcio: HQRS
	//Pawcio: Limits for PS
	int m_iPSforPF;//Part files
	int m_iPSforCF;//Complete files
	//Pawcio: Moonlight SUQWT
	int m_bEnableMSUQWT;
	//Sivka: AutoHL
	int m_bEnableAutoHL;
	int m_iHardLimitTimer;
	int m_bEnableACC; //Obelix
	//Sivka: AutoHL
	int m_iHighProcess; //MORPH - Added by IceCream, high process priority
	int m_bEDT; //enkeyDev -EDT-


	CTreeOptionsCtrlEx m_ctrlTreeOptions;
	bool m_bInitializedTreeOpts;
	HTREEITEM m_htiMaxCon5Sec;
	HTREEITEM m_htiAutoTakeEd2kLinks;
	HTREEITEM m_htiVerbose;
	HTREEITEM m_htiDebugSourceExchange;
	HTREEITEM m_htiCreditSystem;
	HTREEITEM m_htiSaveLogs;
	HTREEITEM m_htiLog2Disk;
	HTREEITEM m_htiDebug2Disk;
	HTREEITEM m_htiCommit;
	HTREEITEM m_htiCommitNever;
	HTREEITEM m_htiCommitOnShutdown;
	HTREEITEM m_htiCommitAlways;
	HTREEITEM m_htiFilterLANIPs;
	HTREEITEM m_htiExtControls;
	HTREEITEM m_htiServerKeepAliveTimeout;
	HTREEITEM m_AdditionalTweaks; //Pawcio: Additional Tweaks
	HTREEITEM m_ProReleasersTweaks; //Pawcio: Pro-Releaser
	HTREEITEM m_SourceHandlingTweaks; //Pawcio: Source Handling
	HTREEITEM m_htiPawcioCredits; //Pawcio: Credits
	HTREEITEM m_htiRedFiles; //Pawcio: Red Files
	HTREEITEM m_htiWQOF; //Xman: Waiting Queue Overflow
	HTREEITEM m_htiCheckDiskspace;	// SLUGFILLER: checkDiskspace
	HTREEITEM m_htiMinFreeDiskSpace;
	HTREEITEM m_htiYourHostname;	// itsonlyme: hostnameSource
	HTREEITEM m_htiEnableAntiLeecher; //MORPH - Added by IceCream, enable Anti-leecher
	HTREEITEM m_htiEnableAntiCreditHack; //MORPH - Added by IceCream, enable Anti-CreditHack
	HTREEITEM m_htiIsAutoPowershareNewDownloadFile;//MORPH - Added by SiRoB, Avoid misusing of powersharing
	// The Black Hand: Antivirus Check - Pawcio
	HTREEITEM otiAV;
	HTREEITEM otiAVParameter;
	HTREEITEM otiAVFileCheck;
	HTREEITEM otiFile;
	int			m_iAV;
	CString		m_sAVFile;
	CString		m_sAVParameters;
	// The Black Hand: Antivirus Check - Pawcio
	// SLUGFILLER: hideOS
	HTREEITEM m_htiHideOS;
	HTREEITEM m_htiSelectiveShare;
	// SLUGFILLER: hideOS
	HTREEITEM m_htiInfiniteQueue;	// SLUGFILLER: infiniteQueue
	HTREEITEM m_htiDropHQRS; //Pawcio: HQRS
	//Pawcio: Limits for PS
	HTREEITEM m_htiPSforPF;//Part files
	HTREEITEM m_htiPSforCF;//Complete files
	//Pawcio: Moonlight SUQWT
	HTREEITEM m_htiEnableMSUQWT;
	//Sivka: AutoHL
	HTREEITEM m_htiEnableAutoHL;
	HTREEITEM m_htiHardLimitTimer;
	HTREEITEM m_htiEnableACC; //Obelix
	//Sivka: AutoHL
	HTREEITEM m_htiHighProcess; //MORPH - Added by IceCream, high process priority
	HTREEITEM m_htiEDT; //enkeyDev -EDT-


	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	afx_msg LRESULT OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam);

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	void Localize(void);
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnKillActive();
};
